VERSION 5.00
Object = "{3B7C8863-D78F-101B-B9B5-04021C009402}#1.2#0"; "RICHTX32.OCX"
Begin VB.UserControl ctlColourCode 
   ClientHeight    =   1095
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   1350
   Picture         =   "ctlColourCode.ctx":0000
   ScaleHeight     =   1095
   ScaleWidth      =   1350
   ToolboxBitmap   =   "ctlColourCode.ctx":014A
   Begin RichTextLib.RichTextBox rtfTemp 
      Height          =   1095
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Visible         =   0   'False
      Width           =   1335
      _ExtentX        =   2355
      _ExtentY        =   1931
      _Version        =   393217
      Enabled         =   -1  'True
      TextRTF         =   $"ctlColourCode.ctx":045C
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Courier New"
         Size            =   9
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
   End
End
Attribute VB_Name = "ctlColourCode"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'--
'Author: Sam Huggill
'Date: 15/5/99
'Time: 10:28
'Colour control for colourizing VB code in a rich text box
'Calls the ColorizeWords function in the Colourize module
'--

Option Explicit

Const m_def_ColourKeyword = 0
Const m_def_ColourComment = 0
Const m_def_ColourText = 0

Dim m_ColourKeyword As Variant
Dim m_ColourComment As Variant
Dim m_ColourText As OLE_COLOR

Public Property Get ColourKeyword() As OLE_COLOR
    '--
    'Return the Keyword Colour
    '--
    ColourKeyword = m_ColourKeyword
End Property

Public Property Let ColourKeyword(ByVal New_ColourKeyword As OLE_COLOR)
    '--
    'Set the Keyword Colour
    '--
    m_ColourKeyword = New_ColourKeyword
    PropertyChanged "ColourKeyword"
    oleKeyword = New_ColourKeyword
    
End Property

Public Property Get ColourComment() As OLE_COLOR
    '--
    'Return the Comment Colour
    '--
    ColourComment = m_ColourComment
End Property

Public Property Let ColourComment(ByVal New_ColourComment As OLE_COLOR)
    '--
    'Set the Comment Colour
    '--
    m_ColourComment = New_ColourComment
    PropertyChanged "ColourComment"
    oleComment = New_ColourComment
    
End Property

Private Sub UserControl_InitProperties()
    '--
    'Set the default property values
    '--
    m_ColourKeyword = m_def_ColourKeyword
    m_ColourComment = m_def_ColourComment
    Set Font = Ambient.Font
    m_ColourText = m_def_ColourTexty
    
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    '--
    'Read the stored values
    '--
    m_ColourKeyword = PropBag.ReadProperty("ColourKeyword", m_def_ColourKeyword)
    m_ColourComment = PropBag.ReadProperty("ColourComment", m_def_ColourComment)
    Set Font = PropBag.ReadProperty("Font", Ambient.Font)
    m_ColourText = PropBag.ReadProperty("ColourText", m_def_ColourText)
    
End Sub

Private Sub UserControl_Resize()
    UserControl.Width = UserControl.Picture.Width
    UserControl.Height = UserControl.Picture.Height
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    '--
    'Write any new values
    '--
    Call PropBag.WriteProperty("ColourKeyword", m_ColourKeyword, m_def_ColourKeyword)
    Call PropBag.WriteProperty("ColourComment", m_ColourComment, m_def_ColourComment)
    Call PropBag.WriteProperty("Font", Font, Ambient.Font)
    Call PropBag.WriteProperty("ColourText", m_ColourText, m_def_ColourText)
    
End Sub

Sub Initalize()
    '--
    'Initalize the words to be coloured and set the public
    'variables
    '--
    InitColorize
    oleComment = m_ColourComment
    oleKeyword = m_ColourKeyword
    oleText = m_ColourText
    
End Sub

Sub Colour(rtf As Object)
    '--
    'Copy the text into our tempory text box, colour it and
    'return the text to the original text box
    '--
    rtfTemp = rtf.TextRTF
    
    Call ColorizeWords(rtfTemp, rtfTemp.Font)
    DoEvents
    
    rtf.TextRTF = rtfTemp.TextRTF
    
End Sub

Public Property Get Font() As Font
Attribute Font.VB_Description = "Returns a Font object."
Attribute Font.VB_UserMemId = -512
    '--
    'Return the Font value
    '--
    Set Font = UserControl.Font
End Property

Public Property Set Font(ByVal New_Font As Font)
    '--
    'Set the new Font
    '--
    Set UserControl.Font = New_Font
    PropertyChanged "Font"
    rtfTemp.Font = New_Font
    
End Property

Public Property Get ColourText() As OLE_COLOR
    '--
    'Return the Text Colour
    '--
    ColourText = m_ColourText
End Property

Public Property Let ColourText(ByVal New_ColourText As OLE_COLOR)
    '--
    'Set the Text Colour
    '--
    m_ColourText = New_ColourText
    PropertyChanged "ColourText"
    
End Property

Sub AboutBox()
Attribute AboutBox.VB_UserMemId = -552
    '--
    'Shows our about box
    '--
    MsgBox "Copyright 1999 VB Square - http://www.programmerz.com/vb/" & Chr(13) & "    Written By Sam Huggill of Lighthouse Internet Solutions"
End Sub
